'use strict';


const moment = require('moment');

module.exports = app => {
  const { STRING, INTEGER, DATE, DECIMAL, TEXT, ENUM } = app.Sequelize;

  const CourseUser = app.classModel.define('course_old_user', {
    id: {
      type: INTEGER,
      primaryKey: true,
      autoIncrement: true,
    },
    uuid: STRING,
    app_id: STRING,
    app_user_id: STRING,
    app_type_id: STRING,
    user_id: STRING,
    phone: STRING,
    nickname: STRING,
    avatar: STRING,
    sex: STRING,
    openid: STRING,
    is_deleted: INTEGER,
    created_at: {
      type: DATE,
      allowNull: true,
      get() {
        const date = this.getDataValue('created_at');
        return date ? moment(date).format('YYYY-MM-DD HH:mm:ss') : undefined;
      },
    },
    updated_at: {
      type: DATE,
      allowNull: true,
      get() {
        const date = this.getDataValue('updated_at');
        return date ? moment(date).format('YYYY-MM-DD HH:mm:ss') : undefined;
      },
    },
  }, {
    timestamps: false,
    tableName: 'course_old_user',
  });

  CourseUser.one = async data => {
    const attributes = data.attributes ? data.attributes : {};
    const where = data.where ? data.where : {};
    return await CourseUser.findOne({
      attributes,
      where,
    });
  };

  CourseUser.all = async data => {
    const attributes = data.attributes ? data.attributes : {};
    const where = data.where ? data.where : {};
    const order = data.order ? data.order : [];
    return await CourseUser.findAll({
      attributes,
      where,
      order,
    });
  };

  CourseUser.list = async (data = {}) => {
    const limit = data.limit ? Number(data.limit) : 10;
    const page = data.page ? data.page : 1;
    const order = data.order ? data.order : [];
    const attributes = data.attributes ? data.attributes : {};
    const where = data.where ? data.where : {};
    const condition = {
      offset: (page - 1) * limit,
      limit,
      where,
      order,
      attributes,
    };
    const { count, rows } = await CourseUser.findAndCountAll(condition);
    return { page, count, rows };
  };

  CourseUser.add = async data => {
    try {
      // 返回promise对象实力 instance
      const res = await CourseUser.create(data);
      // 从promise 实例中中获得需要的id号，id 必须是自增长，而且必须主键，否则返回null
      return res.id;
    } catch (error) {
      throw (error);
    }
  };

  CourseUser.edit = async data => {
    const where = data.where;
    const params = data.params;
    try {
      const res = await CourseUser.update(params, { where });
      return res;
    } catch (error) {
      throw (error);
    }
  };

  return CourseUser;

};
